create database pgconf;
create table a(id bigserial primary key, deleted boolean);

-- \d a

insert into a(deleted) values (false);
select * from a;
select ctid, xmin, xmax, * from a;
select txid_current();

create extension pageinspect;

SELECT t_ctid, t_xmin, t_xmax, tuple_data_split('a'::regclass, t_data, t_infomask, t_infomask2, t_bits) FROM heap_page_items(get_raw_page('a', 0));

explain select * from a where ctid = '(0,1)';
explain select * from a where id = 1;

select n_tup_hot_upd from pg_stat_user_tables where relname = 'a';


-- now lets do a soft delete
update a set deleted = true where ctid = '(0,1)';

select n_tup_hot_upd from pg_stat_user_tables where relname = 'a';

-- phew, that was hot

SELECT t_ctid, t_xmin, t_xmax, tuple_data_split('a'::regclass, t_data, t_infomask, t_infomask2, t_bits) FROM heap_page_items(get_raw_page('a', 0));

-- we still have a copy, but not in the pkey
SELECT ctid, data  FROM bt_page_items(get_raw_page('a_pkey', 1));

-- create index a_deleted_idx on a(deleted);
create index liveidx on a(id) where not deleted;

SELECT ctid, data  FROM bt_page_items(get_raw_page('a_pkey', 1));
SELECT ctid, data  FROM bt_page_items(get_raw_page('liveidx', 1));
-- no entries yet, so let's undelete our row

update a set deleted = false where ctid = '(0,2)';

select n_tup_hot_upd from pg_stat_user_tables where relname = 'a';
-- no longer hot

update a set deleted = true where ctid = '(0,3)';

select n_tup_hot_upd from pg_stat_user_tables where relname = 'a';
-- deleting is now not a HOT update

SELECT t_ctid, t_xmin, t_xmax, tuple_data_split('a'::regclass, t_data, t_infomask, t_infomask2, t_bits) FROM heap_page_items(get_raw_page('a', 0));
-- keeps growing

SELECT ctid, data  FROM bt_page_items(get_raw_page('a_pkey', 1));
-- same for pkey

 update a set deleted = false where ctid = '(0,4)';
SELECT ctid, data  FROM bt_page_items(get_raw_page('liveidx', 1));
SELECT ctid, data  FROM bt_page_items(get_raw_page('a_pkey', 1));
SELECT t_ctid, t_xmin, t_xmax, tuple_data_split('a'::regclass, t_data, t_infomask, t_infomask2, t_bits) FROM heap_page_items(get_raw_page('a', 0));

delete from a where id = 1;
SELECT t_ctid, t_xmin, t_xmax, tuple_data_split('a'::regclass, t_data, t_infomask, t_infomask2, t_bits) FROM heap_page_items(get_raw_page('a', 0));
SELECT ctid, data  FROM bt_page_items(get_raw_page('liveidx', 1));
-- entries in liveidx did not change
SELECT ctid, data  FROM bt_page_items(get_raw_page('a_pkey', 1));
-- entries in pkey did not change
